
// TestLibForVCDlg.cpp : 实现文件
//

#include "stdafx.h"
#include "TestLibForVC.h"
#include "TestLibForVCDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// 用于应用程序“关于”菜单项的 CAboutDlg 对话框

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// 对话框数据
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 支持

// 实现
protected:
	DECLARE_MESSAGE_MAP()
public:
	
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
	
END_MESSAGE_MAP()


// CTestLibForVCDlg 对话框



CTestLibForVCDlg::CTestLibForVCDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_TESTLIBFORVC_DIALOG, pParent)
	, m_nOcpTime(100)
	, m_sPot(_T(""))
	, m_sI(_T(""))
	, m_sT(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_spDev = NULL;
}

void CTestLibForVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_nOcpTime);
	DDX_Text(pDX, IDC_EDIT2, m_sPot);
	DDX_Text(pDX, IDC_EDIT3, m_sI);
	DDX_Text(pDX, IDC_EDIT4, m_sT);
}

#define CSStudio6Lib_Msg 0x0400+1

BEGIN_MESSAGE_MAP(CTestLibForVCDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(CSStudio6Lib_Msg, OnDataMessage)
	ON_BN_CLICKED(IDC_BUTTON1, &CTestLibForVCDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CTestLibForVCDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CTestLibForVCDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON_CV, &CTestLibForVCDlg::OnBnClickedButtonCv)
END_MESSAGE_MAP()


// CTestLibForVCDlg 消息处理程序

BOOL CTestLibForVCDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// 将“关于...”菜单项添加到系统菜单中。

	// IDM_ABOUTBOX 必须在系统命令范围内。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 设置此对话框的图标。  当应用程序主窗口不是对话框时，框架将自动
	//  执行此操作
	SetIcon(m_hIcon, TRUE);			// 设置大图标
	SetIcon(m_hIcon, FALSE);		// 设置小图标

	m_spDev.CreateInstance(__uuidof(CSStudio6));
	//int x = CSStudio6Msg::DataRev;

	return TRUE;  // 除非将焦点设置到控件，否则返回 TRUE
}

void CTestLibForVCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// 如果向对话框添加最小化按钮，则需要下面的代码
//  来绘制该图标。  对于使用文档/视图模型的 MFC 应用程序，
//  这将由框架自动完成。

void CTestLibForVCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 用于绘制的设备上下文

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 使图标在工作区矩形中居中
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 绘制图标
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//当用户拖动最小化窗口时系统调用此函数取得光标
//显示。
HCURSOR CTestLibForVCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CTestLibForVCDlg::OnBnClickedButton1()
{
	if (m_spDev->FindDevice())
	{
		CString sSN =  m_spDev->GetSerialNumber();
		SetWindowText(sSN);
		//绑定消息句柄
		m_spDev->SetMsgHandle((LONG)GetSafeHwnd());
	}
}
LRESULT CTestLibForVCDlg::OnDataMessage(WPARAM wParam, LPARAM lParam)
{
	if (m_spDev == NULL) return S_FALSE;

	int nType = wParam;

	double dTime = 0, dE = 0, dI = 0;
	if (nType == 0)  //收到数据
	{
		m_spDev->GetLastValue(&dE,&dI,&dTime);

		m_sPot.Format(_T("%f"), dE);
		m_sI.Format(_T("%f"), dI);
		m_sT.Format(_T("%f"), dTime);
		UpdateData(FALSE);
	}
	else if (nType==1)  //测试结束了
	{
		//Stop
	}
	else if (nType == 2) //出错了
	{
		CString sError = m_spDev->GetLastError();
	}


	return S_OK;
}

void CTestLibForVCDlg::OnBnClickedButton2()
{
	UpdateData();
	if (!m_spDev->DeviceIsOpen()) return;	
	m_spDev->SetOcpParams(m_nOcpTime, 5);
	Sleep(500);
	m_spDev->DeviceStart();
}


void CTestLibForVCDlg::OnBnClickedButton3()
{
	m_spDev->DeviceStop();
}


void CTestLibForVCDlg::OnBnClickedButtonCv()
{
	UpdateData();
	if (!m_spDev->DeviceIsOpen()) return;

	m_spDev->SetIRValue(FALSE, 100);
	m_spDev->SetCVParams(3,1,1,2,2,0.01,100,3);

	Sleep(500);
	m_spDev->DeviceStart();
}
